﻿namespace TestBed
{
   using System;
   using Telerik.WinControls.Data;
   using Telerik.WinControls.UI;
   using Telerik.WinControls.UI.Scheduler.ICalendar;

   public class SchedulerICalendarExporter2 : SchedulerICalendarExporter
   {
      private SchedulerResourceCollection m_Resources;

      public SchedulerICalendarExporter2(SchedulerResourceCollection resources)
         : base()
      {
         m_Resources = resources;
      }

      protected override void WriteAdditionalDataForAppointment(IEvent appointment, CalObject calObject)
      {
         base.WriteAdditionalDataForAppointment(appointment, calObject);

         // new);
         if (appointment.ResourceId != null)
         {
            string resources = BuildResources(appointment.ResourceIds);
            calObject.AddProperty("RESOURCES", resources);
         }
      }

      private string BuildResources(ObservableCollection<EventId> resourceIds)
      {
         string res = string.Empty;

         foreach (EventId resourceId in resourceIds)
         {
            string resource = m_Resources.GetById(resourceId.KeyValue).Name;
            if (res == string.Empty)
               res += resource;
            else
            {
               res += "," + resource;
            }
         }

         return res;
      }
   }
}
